g = vim.g
o = vim.o
au = vim.api.nvim_create_autocmd
bo = vim.bo
wo = vim.wo

o.backup = false
o.clipboard = 'unnamedplus'
o.completeopt = 'menu', 'menuone', 'noselect'
o.hlsearch = false
o.ignorecase = true
o.laststatus = 0
o.list = true
o.listchars = 'nbsp:¬,tab:»·,trail:·,extends:>'
o.mouse = 'a'
o.nu = true
o.relativenumber = true
o.scrolloff = 8
o.shiftwidth = 4
o.showcmd = true
o.showmode = true
o.showtabline = 2
o.smartcase = true
o.softtabstop = 4
o.splitright = true
o.swapfile = false
o.tabstop = 4
o.undofile = true

wo.wrap = false

g.fzf_layout = { down = '30%' }
g.is_posix = 1

au({ 'BufWritePre' }, { pattern = { '*' }, command = [[%s/\n\+\%$//e]] })
au({ 'FileType' }, { pattern = { '*' }, command = [[setlocal formatoptions-=cro]] })
